Index: pjproject/trunk/pjnath/include/pjnath/types.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/types.h	(revision 1109)
+++ pjproject/trunk/pjnath/include/pjnath/types.h	(revision 1110)
@@ -29,5 +29,5 @@
 
 /**
- * @defgroup PJNATH NAT Helper Library
+ * @defgroup PJNATH NAT Traversal Helper Library
  * @{
  */
@@ -52,15 +52,154 @@
 
 /**
- * @mainpage NAT Helper Library
- *
- * \n
- * \n
- * \n
- * This is the documentation of PJNATH, an auxiliary library providing
- * NAT helper functionalities such as STUN and ICE.
- * 
- * Please go to the <A HREF="modules.htm"><B>Modules</B></A> page for list
- * of modules.
- *
+ * @mainpage PJNATH - Open Source STUN, TURN, and ICE Library
+ *
+ * \n
+ * This is the documentation of PJNATH, an Open Source library providing
+ * NAT traversal helper functionalities by using standard based protocols 
+ * such as:
+ *  - <b>STUN</b> (Session Traversal Utilities),
+ *  - <b>TURN</b> (Obtaining Relay Addresses from STUN)
+ *  - <b>ICE</b> (Interactive Connectivity Establishment).
+ * 
+ * The following sections will give a short overview about the protocols
+ * supported by this library, and how they are implemented in PJNATH.
+ *
+ * \n
+
+ * \section PJNATH_STUN STUN Protocol Library
+ *
+ * Session Traversal Utilities (STUN, or previously known as Simple 
+ * Traversal of User Datagram Protocol (UDP) Through Network Address 
+ * Translators (NAT)s), was previously released as IETF standard
+ * <A HREF="http://www.ietf.org/rfc/rfc3489.txt">RFC 3489</A>, but since
+ * then it has been revised into the following:
+ *  - <A HREF="http://www.ietf.org/internet-drafts/draft-ietf-behave-rfc3489bis-06.txt">
+ *    <B>draft-ietf-behave-rfc3489bis-06</b></A> for the main STUN 
+ *    specification,
+ *  - <A HREF="http://www.ietf.org/internet-drafts/draft-ietf-behave-turn-03.txt">
+ *    <B>draft-ietf-behave-turn-03</B></A> for TURN usage of STUN,
+ *  - and several other drafts explaining other STUN usages.
+ * 
+ * The PJNATH library provides facilities to support both the core 
+ * <B>STUN-bis</B> specification and the <B>TURN</B> usage of STUN, 
+ * as well as other STUN usages. Please see #pj_stun_attr_type for 
+ * list of STUN attributes supported by this library.
+ *
+ * 
+ * The following are some design principles that have been utilized
+ * when implementing the STUN library in PJNATH:
+ *
+ *  - layered architecture, with \ref PJNATH_STUN_MSG as the lowest
+ *    layer and \ref PJNATH_STUN_SESSION as the highest abstraction
+ *    layer, to accommodate various usage scenario of the library.
+ *
+ *  - no transport -- the STUN library is pretty much transport
+ *    independent and all sending and receiving functionalities will
+ *    have to be implemented by application or higher level
+ *    abstraction (such as ICE). This helps facilitating an even
+ *    more usage scenarios of the library.
+ *
+ *  - common functionalities for both STUN client and server
+ *    development. All STUN components can be used to develop both
+ *    STUN client and STUN server application, and in fact, in ICE,
+ *    both STUN client and server functionality exist in a single
+ *    ICE session.
+ *
+ * \n
+ *
+ * \subsection PJNATH_STUN_ARCH STUN Library Organization
+ *
+
+ \verbatim
+
+    +-----------------------------------------------------------------+
+    |                                                                 |
+    |                   A P P L I C A T I O N                         |
+    |                                                                 |
+    +-----------------------------------------------------------------+
+         ^                          ^
+         |                          |
+         v                          v
+    +--------+    +-----------------------------------+    +----------+
+    |        |    |                                   |    |          |
+    |  Appl- |<-->|      S T U N   S E S S I O N      |<-->| S T U N  |
+    | ication|    |                                   |    |  Authen- |
+    | Trans- |    +-----------------------------------+    | tication |
+    |  port  |    |                                   |    |          |
+    |        |<-->|  S T U N   T R A N S A C T I O N  |    +----------+
+    |        |    |                                   |
+    |        |    +-----------------------------------+
+    |        |    |                                   |
+    |        |    |    STUN MESSAGE REPRESENTATION    |
+    +--------+    |            AND PARSING            |
+                  +-----------------------------------+
+
+ \endverbatim
+
+ * The STUN library is organized as follows:
+ *
+ *  - the lowest layer of the library is \ref PJNATH_STUN_MSG. This layer
+ *    provides STUN message representation, validation, parsing, and
+ *    debugging (dump to log) of STUN messages.
+ *
+ *  - for client, the next higher layer is \ref PJNATH_STUN_TRANSACTION,
+ *    which manages retransmissions of STUN request.
+ *
+ *  - \ref PJNATH_STUN_AUTH provides mechanism to verify STUN
+ *    credential in incoming STUN messages.
+ *
+ *  - for both client and server, the next higher abstraction is
+ *    \ref PJNATH_STUN_SESSION, which provides management of incoming
+ *    and outgoing messages and association of STUN credential to
+ *    a STUN session.
+ *
+ * As mentioned previously, all STUN library components are independent
+ * of any transports. Application gives incoming packet
+ * to the STUN components for processing. and it must supply the STUN 
+ * components with callback to send outgoing messages.
+ * 
+ * \n
+ *
+ * \section PJNATH_ICE ICE Implementation
+ *
+ * Interactive Connectivity Establishment (ICE) is a standard based 
+ * methodology for traversing Network Address Translator (NAT), and
+ * is described in 
+ * <A HREF="http://www.ietf.org/internet-drafts/draft-ietf-mmusic-ice-14.txt">
+ * <B>draft-ietf-mmusic-ice-14.txt</B></A> draft. The PJNATH ICE
+ * implementation is aimed to provide a usable and generic ICE transports
+ * for different types of application, including but not limited to
+ * the usage of ICE in SIP/SDP offer/answer.
+ * 
+ * \subsection PJNATH_ICE_ARCH ICE Library Organization
+ * 
+ * The ICE library is organized as follows:
+ *
+ *  - the lowest layer is \ref PJNATH_ICE_SESSION, which provides 
+ *    ICE management and negotiation in a transport-independent way.
+ *    This layer contains the state machines to perform ICE
+ *    negotiation, and provides the most flexibility to control all
+ *    aspects of ICE session. This layer normally is only usable for
+ *    ICE implementors.
+ *
+ *  - higher in the hierarchy is \ref PJNATH_ICE_STREAM_TRANSPORT,
+ *    which binds ICE with UDP sockets, and provides STUN binding
+ *    and relay/TURN allocation for the sockets. This component can
+ *    be directly used by application, although normally application
+ *    should use the next higher abstraction below since it provides
+ *    SDP translations and better integration with other PJ libraries
+ *    such as PJSIP and PJMEDIA.
+ *
+ *  - the highest abstraction is ICE media transport, which maintains
+ *    ICE stream transport and provides SDP translations to be used
+ *    for SIP offer/answer exchanges.
+ */
+
+/**
+ * @defgroup PJNATH_STUN STUN Library
+ * @brief Open source STUN library
+ *
+ * This module contains implementation of STUN library in PJNATH -
+ * the open source NAT helper containing STUN and ICE.
  */
 
Index: pjproject/trunk/pjnath/src/pjnath/ice.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/ice.c	(revision 1109)
+++ pjproject/trunk/pjnath/src/pjnath/ice.c	(revision 1110)
@@ -534,9 +534,10 @@
     }
 
-    /* If there's no relayed candidate, find server reflexive candidate */
+    /* If there's no relayed candidate, find reflexive candidate */
     for (i=0; i<ice->lcand_cnt; ++i) {
 	pj_ice_cand *lcand = &ice->lcand[i];
 	if (lcand->comp_id==comp_id &&
-	    lcand->type == PJ_ICE_CAND_TYPE_SRFLX) 
+	    (lcand->type == PJ_ICE_CAND_TYPE_SRFLX ||
+	     lcand->type == PJ_ICE_CAND_TYPE_PRFLX)) 
 	{
 	    *cand_id = GET_LCAND_ID(lcand);
@@ -798,5 +799,7 @@
 
 	/* Call callback */
-	(*ice->cb.on_ice_complete)(ice, status);
+	if (ice->cb.on_ice_complete) {
+	    (*ice->cb.on_ice_complete)(ice, status);
+	}
     }
 }
Index: pjproject/trunk/pjnath/src/pjnath/ice_stream_transport.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/ice_stream_transport.c	(revision 1109)
+++ pjproject/trunk/pjnath/src/pjnath/ice_stream_transport.c	(revision 1110)
@@ -195,5 +195,5 @@
     PJ_ASSERT_RETURN(ice_st, PJ_EINVAL);
     /* Must not have pending resolver job */
-    PJ_ASSERT_RETURN(ice_st->has_resolver_job==PJ_FALSE, PJ_EINVALIDOP);
+    PJ_ASSERT_RETURN(ice_st->has_rjob==PJ_FALSE, PJ_EINVALIDOP);
 
     if (stun_srv) {
@@ -241,5 +241,5 @@
 
     PJ_ASSERT_RETURN(ice_st && comp && addr, PJ_EINVAL);
-    PJ_ASSERT_RETURN(comp->cand_cnt < PJ_ICE_ST_MAX_ALIASES, PJ_ETOOMANY);
+    PJ_ASSERT_RETURN(comp->cand_cnt < PJ_ICE_ST_MAX_CAND, PJ_ETOOMANY);
 
     cand = &comp->cand_list[comp->cand_cnt];
@@ -249,5 +249,5 @@
     cand->status = PJ_SUCCESS;
     pj_memcpy(&cand->addr, addr, sizeof(pj_sockaddr_in));
-    cand->cand_id = -1;
+    cand->ice_cand_id = -1;
     cand->local_pref = local_pref;
     cand->foundation = calc_foundation(ice_st->pool, type, &addr->sin_addr);
@@ -348,5 +348,5 @@
 	/* Socket is bound to INADDR_ANY */
 	unsigned i, ifs_cnt;
-	pj_in_addr ifs[PJ_ICE_ST_MAX_ALIASES-2];
+	pj_in_addr ifs[PJ_ICE_ST_MAX_CAND-2];
 
 	/* Reset default candidate */
@@ -474,5 +474,5 @@
 	    PJ_TODO(DISTINGUISH_BETWEEN_LOCAL_AND_RELAY);
 	    status = pj_ice_on_rx_pkt(ice_st->ice, comp->comp_id, 
-				      comp->cand_list[0].cand_id,
+				      comp->cand_list[0].ice_cand_id,
 				      comp->pkt, bytes_read,
 				      &comp->src_addr, comp->src_addr_len);
@@ -550,5 +550,5 @@
     
     /* Bail out if STUN server is still being resolved */
-    if (ice_st->has_resolver_job)
+    if (ice_st->has_rjob)
 	return PJ_EBUSY;
 
@@ -591,5 +591,5 @@
     cand->type = PJ_ICE_CAND_TYPE_SRFLX;
     cand->status = PJ_EPENDING;
-    cand->cand_id = -1;
+    cand->ice_cand_id = -1;
     cand->local_pref = 65535;
     cand->foundation = calc_foundation(ice_st->pool, PJ_ICE_CAND_TYPE_SRFLX,
@@ -626,5 +626,5 @@
     
     /* Can't add new component while resolver is running */
-    PJ_ASSERT_RETURN(ice_st->has_resolver_job == PJ_FALSE, PJ_EBUSY);
+    PJ_ASSERT_RETURN(ice_st->has_rjob == PJ_FALSE, PJ_EBUSY);
 
 
@@ -749,5 +749,5 @@
 				     &cand->addr, &comp->local_addr, NULL, 
 				     sizeof(pj_sockaddr_in), 
-				     (unsigned*)&cand->cand_id);
+				     (unsigned*)&cand->ice_cand_id);
 	    if (status != PJ_SUCCESS)
 		goto on_error;
@@ -828,5 +828,5 @@
 	unsigned j;
 	for (j=0; j<ice_st->comp[i]->cand_cnt; ++j) {
-	    ice_st->comp[i]->cand_list[j].cand_id = -1;
+	    ice_st->comp[i]->cand_list[j].ice_cand_id = -1;
 	}
     }
@@ -859,4 +859,11 @@
     }
 
+#if 1
+    PJ_UNUSED_ARG(pkt_size);
+    PJ_UNUSED_ARG(status);
+
+    /* Otherwise return error */
+    return PJNATH_EICEINPROGRESS;
+#else
     /* Otherwise send direcly with the socket */
     pkt_size = data_len;
@@ -866,4 +873,5 @@
     
     return (status==PJ_SUCCESS||status==PJ_EPENDING) ? PJ_SUCCESS : status;
+#endif
 }
 
